module DanglingRibs
  class DanglingRibs
    def word_list=(list)
      @words = list.map do |word|
        word.downcase
      end
    end

    def new_game(guesses_left)
      @left = [true] * 26
      @words_left = @words.dup
    end

    def guess(pattern, guesses_left)
      trim_words(pattern)
      @counts = [0] * 26
      @guess = 0
      @max = 0
      make_guess
      @left[@guess] = false
      (?a + @guess).chr
    end
    
    def trim_words(pattern)
      pattern = /^#{pattern.tr('_', '.')}$/i
      @words_left = @words_left.grep pattern
    end
    
    def make_guess
      @words_left.each do |word|
        count_remaining_letters(word)
      end
    end
    
    def count_remaining_letters(word)
      word.each_byte do |letter|
        count_letter(letter - ?a)
      end
    end

    def count_letter(letter)
      if @left[letter]
        count = @counts[letter] += 1
        update_max(count, letter)
      end
    end

    def update_max(count, letter)
      if count > @max
        @guess = letter
        @max = count
      end
    end

    def incorrect_guess(guess)
      @words_left = @words_left.grep /^[^#{guess}]+$/
    end

    def method_missing(*args)
    end
  end
end