require 'lib/dangling_ribs/dangling_ribs'
VERBOSE=false
def play_game(player, word)
  guesses = 6
  correct = ''
  pattern = '_' * word.size

  player.new_game(guesses)
  until guesses == 0 || word == pattern
    puts pattern if VERBOSE
    letter = player.guess(pattern, guesses)
    puts "#{letter}: #{word =~ /#{letter}/i}" if VERBOSE
    raise "Bad guess" unless letter =~ /^[a-z]$/i
    raise "Duplicate" if correct =~ /#{letter}/i
    if word =~ /#{letter}/i
      correct << letter
      player.correct_guess(letter)
    else
      guesses -= 1
      player.incorrect_guess(letter)
    end
    pattern = word.gsub /[^#{correct}]/i, '_' unless correct.empty?
  end
  puts (word == pattern) ? "win" : "lost" if VERBOSE
  word == pattern
end

def play_all(words)
  player = DanglingRibs::DanglingRibs.new
  player.word_list = words
  words.each do |word|
    begin
      puts word unless play_game(player, word)
    rescue
      puts "failed #{word}"
    end
  end
end

words = IO.read(ARGV[0]).map {|line| line.chomp}
#require 'perftools'
#PerfTools::CpuProfiler.start("play_all.pprof") do
  play_all(words)
#end