require 'lib/dangling_ribs/dangling_ribs'
VERBOSE=TRUE
def play_game(player, word)
  guesses = 6
  correct = ''
  pattern = '_' * word.size

  player.new_game(guesses)
  until guesses == 0 || word == pattern
    puts pattern if VERBOSE
    letter = player.guess(pattern, guesses)
    puts "#{letter}: #{word =~ /#{letter}/i}" if VERBOSE
    raise "Bad guess" unless letter =~ /^[a-z]$/i
    raise "Duplicate" if correct =~ /#{letter}/i
    if word =~ /#{letter}/i
      correct << letter
      player.correct_guess(letter)
    else
      guesses -= 1
      player.incorrect_guess(letter)
    end
    pattern = word.gsub /[^#{correct}]/i, '_' unless correct.empty?
  end
  puts (word == pattern) ? "win" : "lose" if VERBOSE
  word == pattern
end

words = IO.read(ARGV[0]).map {|line| line.chomp}

player = DanglingRibs::DanglingRibs.new
player.word_list = words
play_game(player, ARGV[1])
