require File.expand_path(File.dirname(__FILE__) + "/../spec_helper")
require 'dangling_ribs/dangling_ribs'

VERBOSE = true

describe DanglingRibs::DanglingRibs do

  it "should be instantiable with no paramters" do

    lambda { DanglingRibs::DanglingRibs.new }.should_not raise_error

  end
  
  def play_game(player, word)
    guesses = 6
    correct = ''
    pattern = '_' * word.size

    player.new_game(guesses)
    until guesses == 0 || word == pattern
      puts pattern if VERBOSE
      letter = player.guess(pattern, guesses)
      puts "#{letter}: #{word =~ /#{letter}/}" if VERBOSE
      raise "Bad guess" unless letter =~ /^[a-z]$/
      raise "Duplicate" if correct =~ /#{letter}/
      if word =~ /#{letter}/
        correct << letter
        player.correct_guess(letter)
      else
        guesses -= 1
        player.incorrect_guess(letter)
      end
      pattern = word.gsub /[^#{correct}]/, '_' unless correct.empty?
    end
    puts (word == pattern) ? "win" : "lose" if VERBOSE
    word == pattern
  end
  
  def play_n(words, n)
    player = DanglingRibs::DanglingRibs.new
    player.word_list = words
    results = []
    n.times do
      word = words[rand(words.size)]
      results << play_game(player, word)
    end
    results
  end
  
  it "should win" do
    play_n(%w(ab bc cd de ef), 5).should == [true] * 5
  end

end